diff --git a/src/window.c b/src/window.c
index 881bbd5..f252a36 100644
--- a/src/window.c
+++ b/src/window.c
@@ -53,18 +53,18 @@ static int
 reallocWindowPrivates (int  size,
 		       void *closure)
 {
-    CompScreen *s = (CompScreen *) closure;
-    CompWindow *w;
+    CompWindow *c, *w = (CompWindow *) closure;
     void       *privates;
 
-    for (w = s->windows; w; w = w->next)
-    {
-	privates = realloc (w->base.privates, size * sizeof (CompPrivate));
-	if (!privates)
-	    return FALSE;
+    privates = realloc (w->base.privates, size * sizeof (CompPrivate));
+    if (!privates)
+	return FALSE;
 
-	w->base.privates = (CompPrivate *) privates;
-    }
+    w->base.privates = (CompPrivate *) privates;
+
+    for (c = w->windows; c; c = c->next)
+	if (!reallocWindowPrivates (size, (void *) c))
+	    return FALSE;
 
     return TRUE;
 }
@@ -77,7 +77,7 @@ allocWindowObjectPrivateIndex (CompObject *parent)
     return allocatePrivateIndex (&screen->windowPrivateLen,
 				 &screen->windowPrivateIndices,
 				 reallocWindowPrivates,
-				 (void *) screen);
+				 (void *) &screen->root);
 }
 
 void
@@ -98,15 +98,16 @@ forEachWindowObject (CompObject	        *parent,
 {
     if (parent->type == COMP_OBJECT_TYPE_SCREEN)
     {
-	CompWindow *w;
-
-	CORE_SCREEN (parent);
+	if (!(*proc) (&GET_CORE_SCREEN (parent)->root.base, closure))
+	    return FALSE;
+    }
+    else if (parent->type == COMP_OBJECT_TYPE_WINDOW)
+    {
+	CompWindow *c;
 
-	for (w = s->windows; w; w = w->next)
-	{
-	    if (!(*proc) (&w->base, closure))
+	for (c = GET_CORE_WINDOW (parent)->windows; c; c = c->next)
+	    if (!(*proc) (&c->base, closure))
 		return FALSE;
-	}
     }
 
     return TRUE;
@@ -130,14 +131,23 @@ findWindowObject (CompObject *parent,
 {
     if (parent->type == COMP_OBJECT_TYPE_SCREEN)
     {
-	CompWindow *w;
-	Window	   id = atoi (name);
+	Window id = atoi (name);
 
 	CORE_SCREEN (parent);
 
-	for (w = s->windows; w; w = w->next)
-	    if (w->id == id)
-		return &w->base;
+	if (s->root.id == id)
+	    return &s->root.base;
+    }
+    else if (parent->type == COMP_OBJECT_TYPE_WINDOW)
+    {
+	CompWindow *c;
+	Window	   id = atoi (name);
+
+	CORE_WINDOW (parent);
+
+	for (c = w->windows; c; c = c->next)
+	    if (c->id == id)
+		return &c->base;
     }
 
     return NULL;
@@ -168,8 +178,7 @@ isAncestorTo (CompWindow *transient,
 	if (transient->transientFor == ancestor->id)
 	    return TRUE;
 
-	transient = findWindowAtScreen (transient->screen,
-					transient->transientFor);
+	transient = findSibling (transient, transient->transientFor);
 	if (transient)
 	    return isAncestorTo (transient, ancestor);
     }
@@ -376,7 +385,7 @@ updateTransientHint (CompWindow *w)
     {
 	CompWindow *ancestor;
 
-	ancestor = findWindowAtScreen (w->screen, transientFor);
+	ancestor = findSibling (w, transientFor);
 	if (!ancestor)
 	    return;
 
@@ -426,7 +435,7 @@ getClientLeaderOfAncestor (CompWindow *w)
 {
     if (w->transientFor)
     {
-	w = findWindowAtScreen (w->screen, w->transientFor);
+	w = findSibling (w, w->transientFor);
 	if (w)
 	{
 	    if (w->clientLeader)
@@ -1153,6 +1162,33 @@ setWindowProp32 (CompDisplay    *display,
 		     (unsigned char *) &value32, 1);
 }
 
+Window
+getFrameWindow (CompWindow *w)
+{
+    Atom	  actual;
+    int		  result, format;
+    unsigned long n, left;
+    unsigned char *data;
+
+    result = XGetWindowProperty (w->screen->display->display, w->id,
+				 w->screen->display->frameWindowAtom,
+				 0L, 1L, False, XA_WINDOW, &actual, &format,
+				 &n, &left, &data);
+
+    if (result == Success && n && data)
+    {
+	Window win;
+
+	memcpy (&win, data, sizeof (Window));
+	XFree ((void *) data);
+
+	if (win)
+	    return win;
+    }
+
+    return None;
+}
+
 static void
 updateFrameWindow (CompWindow *w)
 {
@@ -1181,7 +1217,7 @@ updateFrameWindow (CompWindow *w)
 	    attr.event_mask	   = 0;
 	    attr.override_redirect = TRUE;
 
-	    w->frame = XCreateWindow (d->display, w->screen->root,
+	    w->frame = XCreateWindow (d->display, w->parent->id,
 				      x, y, width, height, 0,
 				      CopyFromParent,
 				      InputOnly,
@@ -1281,14 +1317,17 @@ setWindowFrameExtents (CompWindow	 *w,
 	data[2] = input->top;
 	data[3] = input->bottom;
 
-	updateWindowSize (w);
-	updateFrameWindow (w);
-	recalcWindowActions (w);
-
-	XChangeProperty (w->screen->display->display, w->id,
-			 w->screen->display->frameExtentsAtom,
-			 XA_CARDINAL, 32, PropModeReplace,
-			 (unsigned char *) data, 4);
+	if (w->parent->substructureRedirect)
+	{
+	    updateWindowSize (w);
+	    updateFrameWindow (w);
+	    recalcWindowActions (w);
+
+	    XChangeProperty (w->screen->display->display, w->id,
+			     w->screen->display->frameExtentsAtom,
+			     XA_CARDINAL, 32, PropModeReplace,
+			     (unsigned char *) data, 4);
+	}
     }
 }
 
@@ -1397,7 +1436,7 @@ freeWindow (CompWindow *w)
 
     destroyTexture (w->screen, w->texture);
 
-    if (w->frame)
+    if (w->frame && w->parent->substructureRedirect)
 	XDestroyWindow (w->screen->display->display, w->frame);
 
     if (w->clip)
@@ -1446,9 +1485,6 @@ damageTransformedWindowRect (CompWindow *w,
 {
     REGION reg;
 
-    reg.rects    = &reg.extents;
-    reg.numRects = 1;
-
     reg.extents.x1 = (rect->x1 * xScale) - 1;
     reg.extents.y1 = (rect->y1 * yScale) - 1;
     reg.extents.x2 = (rect->x2 * xScale + 0.5f) + 1;
@@ -1461,10 +1497,17 @@ damageTransformedWindowRect (CompWindow *w,
 
     if (reg.extents.x2 > reg.extents.x1 && reg.extents.y2 > reg.extents.y1)
     {
-	reg.extents.x1 += w->attrib.x + w->attrib.border_width;
-	reg.extents.y1 += w->attrib.y + w->attrib.border_width;
-	reg.extents.x2 += w->attrib.x + w->attrib.border_width;
-	reg.extents.y2 += w->attrib.y + w->attrib.border_width;
+	CompWindow *p = w;
+
+	do {
+	    reg.extents.x1 += p->attrib.x + p->attrib.border_width;
+	    reg.extents.y1 += p->attrib.y + p->attrib.border_width;
+	    reg.extents.x2 += p->attrib.x + p->attrib.border_width;
+	    reg.extents.y2 += p->attrib.y + p->attrib.border_width;
+	} while ((p = p->parent));
+
+	reg.rects    = &reg.extents;
+	reg.numRects = reg.size = 1;
 
 	damageScreenRegion (w->screen, &reg);
     }
@@ -1527,19 +1570,27 @@ addWindowDamageRect (CompWindow *w,
 		     BoxPtr     rect)
 {
     REGION region;
+    Bool   status = TRUE;
 
     if (w->screen->damageMask & COMP_SCREEN_DAMAGE_ALL_MASK)
 	return;
 
     region.extents = *rect;
 
-    if (!(*w->screen->damageWindowRect) (w, FALSE, &region.extents))
+    while (w != &w->screen->root)
     {
+	status &= (*w->screen->damageWindowRect) (w, FALSE, &region.extents);
+
 	region.extents.x1 += w->attrib.x + w->attrib.border_width;
 	region.extents.y1 += w->attrib.y + w->attrib.border_width;
 	region.extents.x2 += w->attrib.x + w->attrib.border_width;
 	region.extents.y2 += w->attrib.y + w->attrib.border_width;
 
+	w = w->parent;
+    }
+
+    if (!status)
+    {
 	region.rects = &region.extents;
 	region.numRects = region.size = 1;
 
@@ -1882,21 +1933,123 @@ setDefaultWindowAttributes (XWindowAttributes *wa)
 }
 
 void
-addWindow (CompScreen *screen,
+initRootWindow (CompScreen *s,
+		CompWindow *root)
+{
+    CompWindow  *w = root;
+    CompPrivate	*privates;
+    CompDisplay *d = s->display;
+    REGION      rect;
+
+    memset (w, 0, sizeof (*w));
+
+    w->id     = XRootWindow (d->display, s->screenNum);
+    w->screen = s;
+
+    w->bindFailed = TRUE;
+    w->alive      = TRUE;
+
+    w->mapNum = s->mapNum++;
+
+    w->paint.opacity    = OPAQUE;
+    w->paint.brightness = BRIGHT;
+    w->paint.saturation = COLOR;
+    w->paint.xScale	= 1.0f;
+    w->paint.yScale	= 1.0f;
+    w->paint.xTranslate	= 0.0f;
+    w->paint.yTranslate	= 0.0f;
+
+    w->lastPaint = w->paint;
+
+    if (s->windowPrivateLen)
+    {
+	privates = malloc (s->windowPrivateLen * sizeof (CompPrivate));
+	assert (privates);
+    }
+    else
+	privates = 0;
+
+    compObjectInit (&w->base, privates, COMP_OBJECT_TYPE_WINDOW);
+
+    w->clip   = XCreateRegion ();
+    w->region = XCreateRegion ();
+
+    assert (w->clip && w->region);
+
+    if (!XGetWindowAttributes (d->display, w->id, &w->attrib))
+	setDefaultWindowAttributes (&w->attrib);
+
+    w->attrib.override_redirect = TRUE;
+
+    w->serverWidth	 = w->attrib.width;
+    w->serverHeight	 = w->attrib.height;
+    w->serverBorderWidth = w->attrib.border_width;
+
+    w->width  = w->attrib.width  + w->attrib.border_width * 2;
+    w->height = w->attrib.height + w->attrib.border_width * 2;
+
+    w->serverX = w->attrib.x;
+    w->serverY = w->attrib.y;
+
+    w->syncWait	       = FALSE;
+    w->syncX	       = w->attrib.x;
+    w->syncY	       = w->attrib.y;
+    w->syncWidth       = w->attrib.width;
+    w->syncHeight      = w->attrib.height;
+    w->syncBorderWidth = w->attrib.border_width;
+
+    w->alpha = (w->attrib.depth == 32);
+    w->type  = CompWindowTypeUnknownMask;
+
+    w->invisible = TRUE;
+
+    rect.rects = &rect.extents;
+    rect.numRects = rect.size = 1;
+
+    rect.extents.x1 = w->attrib.x;
+    rect.extents.y1 = w->attrib.y;
+    rect.extents.x2 = w->attrib.x + w->width;
+    rect.extents.y2 = w->attrib.y + w->height;
+
+    XUnionRegion (&rect, w->region, w->region);
+
+    w->substructureRedirect = windowManagement;
+    w->redirectSubwindows   = manualCompositeManagement;
+}
+
+void
+addWindow (CompWindow *parent,
 	   Window     id,
 	   Window     aboveId)
 {
     CompWindow  *w;
     CompPrivate	*privates;
+    CompScreen  *screen = parent->screen;
     CompDisplay *d = screen->display;
 
     w = (CompWindow *) malloc (sizeof (CompWindow));
     if (!w)
 	return;
 
+    w->parent = parent;
+
+    w->windows        = 0;
+    w->reverseWindows = 0;
+
     w->next = NULL;
     w->prev = NULL;
 
+    w->substructureRedirect = FALSE;
+    w->redirectSubwindows   = FALSE;
+
+    w->supportingWmCheckWindow = None;
+    w->syncStateSupport        = FALSE;
+    w->activeChild             = None;
+    w->previousActiveChild     = None;
+
+    w->viewportOffsetX = 0;
+    w->viewportOffsetY = 0;
+    
     w->mapNum	 = 0;
     w->activeNum = 0;
 
@@ -1935,9 +2088,18 @@ addWindow (CompScreen *screen,
     w->pixmap     = None;
     w->destroyed  = FALSE;
     w->damaged    = FALSE;
-    w->redirected = TRUE;
     w->managed    = FALSE;
-    w->bindFailed = FALSE;
+
+    if (parent->redirectSubwindows)
+    {
+	w->redirected = TRUE;
+	w->bindFailed = FALSE;
+    }
+    else
+    {
+	w->redirected = FALSE;
+	w->bindFailed = TRUE;
+    }
 
     w->destroyRefCnt = 1;
     w->unmapRefCnt   = 1;
@@ -1996,11 +2158,15 @@ addWindow (CompScreen *screen,
     w->syncCounter    = 0;
     w->syncWaitHandle = 0;
 
+    XSyncIntToValue (&w->syncValue, 0);
+
     w->closeRequests	    = 0;
     w->lastCloseRequestTime = 0;
 
     w->overlayWindow = FALSE;
 
+    w->desktopWindowCount = 0;
+
     if (screen->windowPrivateLen)
     {
 	privates = malloc (screen->windowPrivateLen * sizeof (CompPrivate));
@@ -2063,10 +2229,23 @@ addWindow (CompScreen *screen,
 
     w->saveMask = 0;
 
-    XSelectInput (d->display, id,
-		  PropertyChangeMask |
-		  EnterWindowMask    |
-		  FocusChangeMask);
+    if (w->parent->substructureRedirect)
+    {
+	XSelectInput (d->display, id,
+		      PropertyChangeMask |
+		      EnterWindowMask    |
+		      FocusChangeMask);
+    }
+    else if (w->parent->redirectSubwindows)
+    {
+	XSelectInput (d->display, id, PropertyChangeMask);
+
+	if (w->parent->syncStateSupport)
+	{
+	    if (!getWindowProp (d, w->id, d->syncStateAtom, 0))
+		syncWait (w);
+	}
+    }
 
     w->id = id;
 
@@ -2083,10 +2262,10 @@ addWindow (CompScreen *screen,
     w->type      = CompWindowTypeUnknownMask;
     w->lastPong  = d->lastPing;
 
-    if (d->shapeExtension)
+    if (d->shapeExtension && parent->redirectSubwindows)
 	XShapeSelectInput (d->display, id, ShapeNotifyMask);
 
-    insertWindowIntoScreen (screen, w, aboveId);
+    insertWindow (parent, w, aboveId);
 
     EMPTY_REGION (w->region);
 
@@ -2104,8 +2283,9 @@ addWindow (CompScreen *screen,
 
 	XUnionRegion (&rect, w->region, w->region);
 
-	w->damage = XDamageCreate (d->display, id,
-				   XDamageReportRawRectangles);
+	if (parent->redirectSubwindows)
+	    w->damage = XDamageCreate (d->display, id,
+				       XDamageReportRawRectangles);
 
 	/* need to check for DisplayModal state on all windows */
 	w->state = getWindowState (d, w->id);
@@ -2115,7 +2295,6 @@ addWindow (CompScreen *screen,
     else
     {
 	w->damage = None;
-	w->attrib.map_state = IsUnmapped;
     }
 
     w->invisible = TRUE;
@@ -2134,6 +2313,9 @@ addWindow (CompScreen *screen,
 	if (!w->clientLeader)
 	    w->startupId = getStartupId (w);
 
+	if (w->parent && !w->parent->substructureRedirect)
+	    w->frame = getFrameWindow (w);
+
 	recalcWindowType (w);
 
 	getMwmHints (d, w->id, &w->mwmFunc, &w->mwmDecor);
@@ -2168,35 +2350,41 @@ addWindow (CompScreen *screen,
     else
 	w->paint.saturation = getWindowProp32 (d, w->id,
 					       d->winSaturationAtom, COLOR);
-	
+
+    getSupportingWmCheck (w);
+
     if (w->attrib.map_state == IsViewable)
     {
 	w->placed = TRUE;
 
 	if (!w->attrib.override_redirect)
 	{
-	    w->managed = TRUE;
-
-	    if (getWmState (d, w->id) == IconicState)
-	    {
-		if (w->state & CompWindowStateShadedMask)
-		    w->shaded = TRUE;
-		else
-		    w->minimized = TRUE;
-	    }
-	    else
+	    if (w->parent->substructureRedirect)
 	    {
-		if (w->wmType & (CompWindowTypeDockMask |
-				 CompWindowTypeDesktopMask))
+		w->managed = TRUE;
+
+		if (getWmState (d, w->id) == IconicState)
 		{
-		    setDesktopForWindow (w, 0xffffffff);
+		    if (w->state & CompWindowStateShadedMask)
+			w->shaded = TRUE;
+		    else
+			w->minimized = TRUE;
 		}
 		else
 		{
-		    if (w->desktop != 0xffffffff)
-			w->desktop = screen->currentDesktop;
+		    if (w->wmType & (CompWindowTypeDockMask |
+				     CompWindowTypeDesktopMask))
+		    {
+			setDesktopForWindow (w, 0xffffffff);
+		    }
+		    else
+		    {
+			if (w->desktop != 0xffffffff)
+			    w->desktop = screen->currentDesktop;
 
-		    setWindowProp (d, w->id, d->winDesktopAtom, w->desktop);
+			setWindowProp (d, w->id, d->winDesktopAtom,
+				       w->desktop);
+		    }
 		}
 	    }
 	}
@@ -2239,7 +2427,7 @@ addWindow (CompScreen *screen,
     /* TODO: bailout properly when objectInitPlugins fails */
     assert (objectInitPlugins (&w->base));
 
-    (*core.objectAdd) (&screen->base, &w->base);
+    (*core.objectAdd) (&parent->base, &w->base);
 
     recalcWindowActions (w);
     updateIconGeometry (w);
@@ -2254,7 +2442,10 @@ addWindow (CompScreen *screen,
 void
 removeWindow (CompWindow *w)
 {
-    unhookWindowFromScreen (w->screen, w);
+    while (w->windows)
+	removeWindow (w->windows);
+
+    unhookWindow (w->parent, w);
 
     if (!w->destroyed)
     {
@@ -2276,7 +2467,7 @@ removeWindow (CompWindow *w)
 	if (w->damage)
 	    XDamageDestroy (d->display, w->damage);
 
-	if (d->shapeExtension)
+	if (d->shapeExtension && w->parent->redirectSubwindows)
 	    XShapeSelectInput (d->display, w->id, NoEventMask);
 
 	XSelectInput (d->display, w->id, NoEventMask);
@@ -2287,7 +2478,7 @@ removeWindow (CompWindow *w)
     if (w->attrib.map_state == IsViewable && w->damaged)
     {
 	if (w->type == CompWindowTypeDesktopMask)
-	    w->screen->desktopWindowCount--;
+	    w->parent->desktopWindowCount--;
 
 	if (w->destroyed && w->struts)
 	    updateWorkareaForScreen (w->screen);
@@ -2296,7 +2487,7 @@ removeWindow (CompWindow *w)
     if (w->destroyed)
 	updateClientListForScreen (w->screen);
 
-    if (!w->redirected)
+    if (w->parent->redirectSubwindows && !w->redirected)
     {
 	w->screen->overlayWindowCount--;
 
@@ -2304,7 +2495,7 @@ removeWindow (CompWindow *w)
 	    showOutputWindow (w->screen);
     }
 
-    (*core.objectRemove) (&w->screen->base, &w->base);
+    (*core.objectRemove) (&w->parent->base, &w->base);
 
     objectFiniPlugins (&w->base);
 
@@ -2384,9 +2575,17 @@ sendConfigureNotify (CompWindow *w)
 void
 mapWindow (CompWindow *w)
 {
+    CompWindow *c;
+
     if (w->attrib.map_state == IsViewable)
 	return;
 
+    if (w->parent->attrib.map_state != IsViewable)
+    {
+	w->attrib.map_state = IsUnviewable;
+	return;
+    }
+
     if (w->pendingMaps > 0)
 	w->pendingMaps--;
 
@@ -2402,7 +2601,7 @@ mapWindow (CompWindow *w)
 
     w->attrib.map_state = IsViewable;
 
-    if (!w->attrib.override_redirect)
+    if (w->managed)
 	setWmState (w->screen->display, NormalState, w->id);
 
     w->invisible  = TRUE;
@@ -2415,21 +2614,28 @@ mapWindow (CompWindow *w)
     updateWindowRegion (w);
     updateWindowSize (w);
 
-    if (w->frame)
+    if (w->frame && w->parent->substructureRedirect)
 	XMapWindow (w->screen->display->display, w->frame);
 
     updateClientListForScreen (w->screen);
 
     if (w->type & CompWindowTypeDesktopMask)
-	w->screen->desktopWindowCount++;
+	w->parent->desktopWindowCount++;
 
-    if (w->protocols & CompWindowProtocolSyncRequestMask)
+    if (w->parent->substructureRedirect)
     {
-	sendSyncRequest (w);
-	sendConfigureNotify (w);
+	if (w->protocols & CompWindowProtocolSyncRequestMask)
+	{
+	    sendSyncRequest (w);
+	    sendConfigureNotify (w);
+	}
+	else
+	{
+	    leaveSyncWaitState (w);
+	}
     }
 
-    if (!w->attrib.override_redirect)
+    if (w->managed)
     {
 	/* been shaded */
 	if (!w->height)
@@ -2438,35 +2644,31 @@ mapWindow (CompWindow *w)
 			  w->attrib.width, ++w->attrib.height - 1,
 			  w->attrib.border_width);
     }
+
+    for (c = w->windows; c; c = c->next)
+	if (c->attrib.map_state == IsUnviewable)
+	    mapWindow (c);
 }
 
-void
-unmapWindow (CompWindow *w)
+static void
+withdrawWindowToState (CompWindow *w,
+		       int        state)
 {
-    if (w->mapNum)
-    {
-	if (w->frame && !w->shaded)
-	    XUnmapWindow (w->screen->display->display, w->frame);
-
-	w->mapNum = 0;
-    }
-
-    w->unmapRefCnt--;
-    if (w->unmapRefCnt > 0)
-	return;
+    CompWindow *c;
 
     if (w->struts)
 	updateWorkareaForScreen (w->screen);
 
-    if (w->attrib.map_state != IsViewable)
+    if (w->attrib.map_state == state)
 	return;
 
     if (w->type == CompWindowTypeDesktopMask)
-	w->screen->desktopWindowCount--;
+	w->parent->desktopWindowCount--;
 
-    addWindowDamage (w);
+    if (w->attrib.map_state == IsViewable)
+	addWindowDamage (w);
 
-    w->attrib.map_state = IsUnmapped;
+    w->attrib.map_state = state;
 
     w->invisible = TRUE;
 
@@ -2482,6 +2684,31 @@ unmapWindow (CompWindow *w)
 
     if (!w->redirected)
 	redirectWindow (w);
+
+    for (c = w->windows; c; c = c->next)
+	if (c->attrib.map_state == IsViewable)
+	    withdrawWindowToState (c, IsUnviewable);
+}
+
+void
+unmapWindow (CompWindow *w)
+{
+    if (w->mapNum)
+    {
+	if (w->frame && w->parent->substructureRedirect && !w->shaded)
+	    XUnmapWindow (w->screen->display->display, w->frame);
+
+	if (w->parent->substructureRedirect)
+	    enterSyncWaitState (w);
+
+	w->mapNum = 0;
+    }
+
+    w->unmapRefCnt--;
+    if (w->unmapRefCnt > 0)
+	return;
+
+    withdrawWindowToState (w, IsUnmapped);
 }
 
 static int
@@ -2496,8 +2723,8 @@ restackWindow (CompWindow *w,
     else if (aboveId == None && !w->next)
 	return 0;
 
-    unhookWindowFromScreen (w->screen, w);
-    insertWindowIntoScreen (w->screen, w, aboveId);
+    unhookWindow (w->parent, w);
+    insertWindow (w->parent, w, aboveId);
 
     updateClientListForScreen (w->screen);
 
@@ -2575,7 +2802,8 @@ resizeWindow (CompWindow *w,
 
 	w->invisible = WINDOW_INVISIBLE (w);
 
-	updateFrameWindow (w);
+	if (w->parent && w->parent->substructureRedirect)
+	    updateFrameWindow (w);
     }
     else if (w->attrib.x != x || w->attrib.y != y)
     {
@@ -2586,7 +2814,7 @@ resizeWindow (CompWindow *w,
 
 	moveWindow (w, dx, dy, TRUE, TRUE);
 
-	if (w->frame)
+	if (w->frame && w->parent->substructureRedirect)
 	    XMoveWindow (w->screen->display->display, w->frame,
 			 w->attrib.x - w->input.left,
 			 w->attrib.y - w->input.top);
@@ -2614,6 +2842,9 @@ initializeSyncCounter (CompWindow *w)
     unsigned long	 n, left;
     unsigned char	 *data;
 
+    if (!w->parent->substructureRedirect)
+	return FALSE;
+
     if (w->syncCounter)
 	return w->syncAlarm != None;
 
@@ -2633,7 +2864,6 @@ initializeSyncCounter (CompWindow *w)
 
 	XFree (data);
 
-	XSyncIntsToValue (&w->syncValue, (unsigned int) rand (), 0);
 	XSyncSetCounter (w->screen->display->display,
 			 w->syncCounter,
 			 w->syncValue);
@@ -2689,6 +2919,20 @@ syncWaitTimeout (void *closure)
 }
 
 void
+syncWait (CompWindow *w)
+{
+    w->syncWait	       = TRUE;
+    w->syncX	       = w->serverX;
+    w->syncY	       = w->serverY;
+    w->syncWidth       = w->serverWidth;
+    w->syncHeight      = w->serverHeight;
+    w->syncBorderWidth = w->serverBorderWidth;
+
+    if (!w->syncWaitHandle)
+	w->syncWaitHandle = compAddTimeout (1000, 1200, syncWaitTimeout, w);
+}
+
+void
 sendSyncRequest (CompWindow *w)
 {
     XClientMessageEvent xev;
@@ -2697,7 +2941,10 @@ sendSyncRequest (CompWindow *w)
 	return;
 
     if (!initializeSyncCounter (w))
+    {
+	leaveSyncWaitState (w);
 	return;
+    }
 
     xev.type	     = ClientMessage;
     xev.window	     = w->id;
@@ -2711,23 +2958,26 @@ sendSyncRequest (CompWindow *w)
 
     syncValueIncrement (&w->syncValue);
 
-    XSendEvent (w->screen->display->display, w->id, FALSE, 0, (XEvent *) &xev);
+    enterSyncWaitState (w);
 
-    w->syncWait	       = TRUE;
-    w->syncX	       = w->serverX;
-    w->syncY	       = w->serverY;
-    w->syncWidth       = w->serverWidth;
-    w->syncHeight      = w->serverHeight;
-    w->syncBorderWidth = w->serverBorderWidth;
+    XSendEvent (w->screen->display->display, w->id, FALSE, 0, (XEvent *) &xev);
 
-    if (!w->syncWaitHandle)
-	w->syncWaitHandle = compAddTimeout (1000, 1200, syncWaitTimeout, w);
+    syncWait (w);
 }
 
 void
 configureWindow (CompWindow	 *w,
 		 XConfigureEvent *ce)
 {
+    if (!w->managed)
+    {
+	w->serverX	     = ce->x;
+	w->serverY	     = ce->y;
+	w->serverWidth       = ce->width;
+	w->serverHeight      = ce->height;
+	w->serverBorderWidth = ce->border_width;
+    }
+
     if (w->syncWait)
     {
 	w->syncX	   = ce->x;
@@ -2738,15 +2988,6 @@ configureWindow (CompWindow	 *w,
     }
     else
     {
-	if (ce->override_redirect)
-	{
-	    w->serverX		 = ce->x;
-	    w->serverY		 = ce->y;
-	    w->serverWidth       = ce->width;
-	    w->serverHeight      = ce->height;
-	    w->serverBorderWidth = ce->border_width;
-	}
-
 	resizeWindow (w, ce->x, ce->y, ce->width, ce->height,
 		      ce->border_width);
     }
@@ -2755,6 +2996,9 @@ configureWindow (CompWindow	 *w,
 
     if (restackWindow (w, ce->above))
 	addWindowDamage (w);
+
+    if (!w->parent)
+	configureScreen (w->screen, ce);
 }
 
 void
@@ -2764,7 +3008,7 @@ circulateWindow (CompWindow	 *w,
     Window newAboveId;
 
     if (ce->place == PlaceOnTop)
-	newAboveId = getTopWindow (w->screen);
+	newAboveId = getTopWindow (w->parent);
     else
 	newAboveId = 0;
 
@@ -2800,29 +3044,12 @@ moveWindow (CompWindow *w,
     }
 }
 
-void
-syncWindowPosition (CompWindow *w)
-{
-    w->serverX = w->attrib.x;
-    w->serverY = w->attrib.y;
-
-    XMoveWindow (w->screen->display->display, w->id, w->attrib.x, w->attrib.y);
-
-    if (w->frame)
-	XMoveWindow (w->screen->display->display, w->frame,
-		     w->serverX - w->input.left,
-		     w->serverY - w->input.top);
-}
-
 Bool
 focusWindow (CompWindow *w)
 {
     if (w->attrib.override_redirect)
 	return FALSE;
 
-    if (!w->managed)
-	return FALSE;
-
     if (!onCurrentDesktop (w))
 	return FALSE;
 
@@ -2902,7 +3129,8 @@ isGroupTransient (CompWindow *w,
     if (!clientLeader)
 	return FALSE;
 
-    if (w->transientFor == None || w->transientFor == w->screen->root)
+    if (w->transientFor == None ||
+	(w->parent && w->transientFor == w->parent->id))
     {
 	if (w->type & (CompWindowTypeDialogMask |
 		       CompWindowTypeModalDialogMask))
@@ -2922,7 +3150,7 @@ getModalTransient (CompWindow *window)
 
     modalTransient = window;
 
-    for (w = window->screen->reverseWindows; w; w = w->prev)
+    for (w = window->parent->reverseWindows; w; w = w->prev)
     {
 	if (w == modalTransient || w->mapNum == 0)
 	    continue;
@@ -2932,7 +3160,7 @@ getModalTransient (CompWindow *window)
 	    if (w->state & CompWindowStateModalMask)
 	    {
 		modalTransient = w;
-		w = window->screen->reverseWindows;
+		w = window->parent->reverseWindows;
 	    }
 	}
     }
@@ -2944,7 +3172,7 @@ getModalTransient (CompWindow *window)
 	if (window->state & CompWindowStateModalMask)
 	    return NULL;
 
-	for (w = window->screen->reverseWindows; w; w = w->prev)
+	for (w = window->parent->reverseWindows; w; w = w->prev)
 	{
 	    if (w == modalTransient || w->mapNum == 0)
 		continue;
@@ -2980,14 +3208,18 @@ moveInputFocusToWindow (CompWindow *w)
     CompDisplay *d = s->display;
     CompWindow  *modalTransient;
 
+    if (!w->managed)
+	return;
+
     modalTransient = getModalTransient (w);
     if (modalTransient)
 	w = modalTransient;
 
     if (w->state & CompWindowStateHiddenMask)
     {
-	XSetInputFocus (d->display, w->frame, RevertToPointerRoot, CurrentTime);
-	XChangeProperty (d->display, s->root, d->winActiveAtom,
+	XSetInputFocus (d->display, w->frame, RevertToPointerRoot,
+			CurrentTime);
+	XChangeProperty (d->display, w->parent->id, d->winActiveAtom,
 			 XA_WINDOW, 32, PropModeReplace,
 			 (unsigned char *) &w->id, 1);
     }
@@ -3027,7 +3259,9 @@ moveInputFocusToWindow (CompWindow *w)
 	    CompWindow *ancestor;
 
 	    /* move input to closest ancestor */
-	    for (ancestor = s->windows; ancestor; ancestor = ancestor->next)
+	    for (ancestor = w->parent->windows;
+		 ancestor;
+		 ancestor = ancestor->next)
 	    {
 		if (isAncestorTo (w, ancestor))
 		{
@@ -3111,7 +3345,7 @@ findSiblingBelow (CompWindow *w,
     if (w->transientFor || isGroupTransient (w, clientLeader))
 	clientLeader = None;
 
-    for (below = w->screen->reverseWindows; below; below = below->prev)
+    for (below = w->parent->reverseWindows; below; below = below->prev)
     {
 	if (below == w || avoidStackingRelativeTo (below))
 	    continue;
@@ -3157,7 +3391,7 @@ findSiblingBelow (CompWindow *w,
 static CompWindow *
 findLowestSiblingBelow (CompWindow *w)
 {
-    CompWindow   *below, *lowest = w->screen->reverseWindows;
+    CompWindow   *below, *lowest = w->parent->reverseWindows;
     Window	 clientLeader = w->clientLeader;
     unsigned int type = w->type;
 
@@ -3169,7 +3403,7 @@ findLowestSiblingBelow (CompWindow *w)
     if (w->transientFor || isGroupTransient (w, clientLeader))
 	clientLeader = None;
 
-    for (below = w->screen->reverseWindows; below; below = below->prev)
+    for (below = w->parent->reverseWindows; below; below = below->prev)
     {
 	if (below == w || avoidStackingRelativeTo (below))
 	    continue;
@@ -3351,6 +3585,55 @@ reconfigureXWindow (CompWindow	   *w,
 		    unsigned int   valueMask,
 		    XWindowChanges *xwc)
 {
+    if (!w->parent->substructureRedirect)
+    {
+	XEvent xev;
+        int    mask = 0;
+
+	valueMask |=
+	    adjustConfigureRequestForGravity (w,
+					      xwc, valueMask,
+					      w->sizeHints.win_gravity,
+					      -1);
+
+	xev.xclient.type    = ClientMessage;
+	xev.xclient.display = w->screen->display->display;
+	xev.xclient.format  = 32;
+
+	xev.xclient.message_type = w->screen->display->moveResizeWindowAtom;
+	xev.xclient.window	 = w->id;
+
+	xev.xclient.data.l[0] = (ClientTypePager << 12);
+
+	if (valueMask & CWX)
+	    xev.xclient.data.l[0] |= (1 << 8);
+
+	if (valueMask & CWY)
+	    xev.xclient.data.l[0] |= (1 << 9);
+
+	if (valueMask & CWWidth)
+	    xev.xclient.data.l[0] |= (1 << 9);
+
+	if (valueMask & CWHeight)
+	    xev.xclient.data.l[0] |= (1 << 9);
+
+	xev.xclient.data.l[1] = xwc->x;
+	xev.xclient.data.l[2] = xwc->y;
+	xev.xclient.data.l[3] = xwc->width;
+	xev.xclient.data.l[4] = xwc->height;
+
+        if (w->parent == &w->screen->root)
+            mask = SubstructureRedirectMask | SubstructureNotifyMask;
+
+	XSendEvent (w->screen->display->display,
+		    w->parent->id,
+		    FALSE,
+		    mask,
+		    &xev);
+
+	return;
+    }
+	
     if (valueMask & CWX)
 	w->serverX = xwc->x;
 
@@ -3368,9 +3651,31 @@ reconfigureXWindow (CompWindow	   *w,
 
     XConfigureWindow (w->screen->display->display, w->id, valueMask, xwc);
 
-    if (w->frame && (valueMask & (CWSibling | CWStackMode)))
+    if (w->frame && (valueMask & (CWSibling | CWStackMode | CWX | CWY)))
+    {
+	XWindowChanges wc = *xwc;
+
+	wc.x -= w->input.left;
+	wc.y -= w->input.top;
+	    
 	XConfigureWindow (w->screen->display->display, w->frame,
-			  valueMask & (CWSibling | CWStackMode), xwc);
+			  valueMask & (CWSibling | CWStackMode | CWX | CWY),
+			  &wc);
+
+    }
+}
+
+void
+syncWindowPosition (CompWindow *w)
+{
+    XWindowChanges xwc;
+
+    xwc.x      = w->attrib.x;
+    xwc.y      = w->attrib.y;
+    xwc.width  = w->serverWidth;
+    xwc.height = w->serverHeight;
+
+    reconfigureXWindow (w, CWX | CWY, &xwc);
 }
 
 static Bool
@@ -3384,7 +3689,7 @@ stackTransients (CompWindow	*w,
     if (w->transientFor || isGroupTransient (w, clientLeader))
 	clientLeader = None;
 
-    for (t = w->screen->reverseWindows; t; t = t->prev)
+    for (t = w->parent->reverseWindows; t; t = t->prev)
     {
 	if (t == w || t == avoid)
 	    continue;
@@ -3417,7 +3722,7 @@ stackAncestors (CompWindow     *w,
     {
 	CompWindow *ancestor;
 
-	ancestor = findWindowAtScreen (w->screen, w->transientFor);
+	ancestor = findSibling (w, w->transientFor);
 	if (ancestor)
 	{
 	    if (!stackTransients (ancestor, w, xwc))
@@ -3442,7 +3747,7 @@ stackAncestors (CompWindow     *w,
     {
 	CompWindow *a;
 
-	for (a = w->screen->reverseWindows; a; a = a->prev)
+	for (a = w->parent->reverseWindows; a; a = a->prev)
 	{
 	    if (a->clientLeader == w->clientLeader &&
 		a->transientFor == None		   &&
@@ -3709,7 +4014,8 @@ unsigned int
 adjustConfigureRequestForGravity (CompWindow     *w,
 				  XWindowChanges *xwc,
 				  unsigned int   xwcm,
-				  int            gravity)
+				  int            gravity,
+				  int		 direction)
 {
     int          newX, newY;
     unsigned int mask = 0;
@@ -3724,23 +4030,23 @@ adjustConfigureRequestForGravity (CompWindow     *w,
 	case WestGravity:
 	case SouthWestGravity:
 	    if (xwcm & CWX)
-		newX += w->input.left;
+		newX += w->input.left * direction;
 	    break;
 
 	case NorthGravity:
 	case CenterGravity:
 	case SouthGravity:
 	    if (!(xwcm & CWX))
-		newX += (w->serverWidth - xwc->width) / 2;
+		newX += ((w->serverWidth - xwc->width) / 2) * direction;
 	    break;
 
 	case NorthEastGravity:
 	case EastGravity:
 	case SouthEastGravity:
 	    if (xwcm & CWX)
-		newX -= w->input.right;
+		newX -= w->input.right * direction;
 	    else
-		newX += w->serverWidth - xwc->width;
+		newX += (w->serverWidth - xwc->width) * direction;
 	    break;
 
 	case StaticGravity:
@@ -3756,23 +4062,23 @@ adjustConfigureRequestForGravity (CompWindow     *w,
 	case NorthGravity:
 	case NorthEastGravity:
 	    if (xwcm & CWY)
-		newY += w->input.top;
+		newY += w->input.top * direction;
 	    break;
 
 	case WestGravity:
 	case CenterGravity:
 	case EastGravity:
 	    if (!(xwcm & CWY))
-		newY += (w->serverHeight - xwc->height) / 2;
+		newY += ((w->serverHeight - xwc->height) / 2) * direction;
 	    break;
 
 	case SouthWestGravity:
 	case SouthGravity:
 	case SouthEastGravity:
 	    if (xwcm & CWY)
-		newY -= w->input.bottom;
+		newY -= w->input.bottom * direction;
 	    else
-		newY += w->serverHeight - xwc->height;
+		newY += (w->serverHeight - xwc->height) * direction;
 	    break;
 
 	case StaticGravity:
@@ -3838,7 +4144,7 @@ moveResizeWindow (CompWindow     *w,
 	}
     }
 
-    xwcm |= adjustConfigureRequestForGravity (w, xwc, xwcm, gravity);
+    xwcm |= adjustConfigureRequestForGravity (w, xwc, xwcm, gravity, 1);
 
     if (!(w->type & (CompWindowTypeDockMask       |
 		     CompWindowTypeFullscreenMask |
